#!/bin/bash

# 第1引数:ログファイル名のサフィックス
[ "x" = "x${1}" ] && exit 1
l=$1

if [ $(whoami) != "root" ]; then
	echo "must execute as root."
	exit
fi

export FILENAME="fio.tmp"
export MOUNTON="/mnt/target"
export FILEPATH="${MOUNTON}/${FILENAME}"

df -Th | egrep target
echo
ps aux | egrep '^root.*fio' | grep -v grep
echo
ls -lh *.${l}
echo
ls -lh ${MOUNTON}/${FILENAME}*

echo "Starting I/O benchmark"
read -p "Quit? (y/N) " q
case $q in
    [yY]* ) echo "quit"
            exit 1
    ;;
esac

rm -f *.${l}
rm -f ${MOUNTON}/${FILENAME}*

for i in *.fio ; do
    echo $i
    for BLOCKSIZE in "4k" "16k" ; do
        export BLOCKSIZE
        for FILESIZE in "1g" "2g" "4g" "8g"; do
            export FILESIZE
            echo "size:${FILESIZE}"
            echo "  fio --output=${i}.${BLOCKSIZE}.${FILESIZE}.${l} $i"
            fio --output=${i}.${BLOCKSIZE}.${FILESIZE}.${l} $i
            [ $? -gt 0 ] && exit 1
            echo "  :fio done"
            sleep 1
            sync
            echo "  :sync done"
            echo  >> ${i}.${BLOCKSIZE}.${FILESIZE}.${l}
            echo "--mount -----------------" >> ${i}.${BLOCKSIZE}.${FILESIZE}.${l}
            mount | egrep ${MOUNTON} >> ${i}.${BLOCKSIZE}.${FILESIZE}.${l}
            echo "--tune2fs -----------------" >> ${i}.${BLOCKSIZE}.${FILESIZE}.${l}
            tune2fs -l $(mount | egrep ${MOUNTON} | awk '{print $1}') >> ${i}.${BLOCKSIZE}.${FILESIZE}.${l}
            echo "--debugfs -----------------" >> ${i}.${BLOCKSIZE}.${FILESIZE}.${l}
            # stat対象のファイルが1つなら、「debugfs -R "stat <マウントポイントからのパス>" <デバイス名>」 でよいが、複数あるのでヒアドキュメントを使う
            debugfs $(mount | egrep ${MOUNTON} | awk '{print $1}') << -- >> ${i}.${BLOCKSIZE}.${FILESIZE}.${l}
stat /${FILENAME}.1
stat /${FILENAME}.2
stat /${FILENAME}.3
stat /${FILENAME}.4
stat /${FILENAME}.5
stat /${FILENAME}.6
stat /${FILENAME}.7
stat /${FILENAME}.8 
--
            echo "  rm ${FILEPATH}.?"
            rm ${FILEPATH}.?
            [ $? -gt 0 ] && exit 1
            echo "  :rm done"
            sleep 1
        done
    done
done
